"""Enumeration of valid modifiers for search arguments
"""
EQUALS = 'eq'
NOT_EQUAL = 'neq'
GREATER_THAN = 'gt'
GREATER_THAN_EQUAL = 'gte'
LESS_THAN = 'lt'
LESS_THAN_EQUAL = 'lte'
IN = 'in'
NOT_IN = 'nin'
LIKE = 'like'
NOT_LIKE = 'nlike'
STARTS_WITH = 'start'
DOES_NOT_START_WITH = 'nstart'
ENDS_WITH = 'end'
DOES_NOT_END_WITH = 'nend'

# Date-specific
ON = 'on'
AFTER = 'after'
BEFORE = 'before'

DEFAULT = EQUALS
DEFAULTS = [EQUALS, NOT_EQUAL]
STRING_DEFAULTS = [EQUALS, NOT_EQUAL, STARTS_WITH, ENDS_WITH, LIKE]
STRING_DEFAULT_MOD = EQUALS
NUMBER_DEFAULTS = [
    EQUALS, NOT_EQUAL, GREATER_THAN, GREATER_THAN_EQUAL, LESS_THAN,
    LESS_THAN_EQUAL
]
NUMBER_DEFAULT_MOD = EQUALS
DATE_DEFAULTS = [
    ON, AFTER, BEFORE, EQUALS, NOT_EQUAL, GREATER_THAN, GREATER_THAN_EQUAL,
    LESS_THAN, LESS_THAN_EQUAL
]
DATE_DEFAULT_MOD = AFTER
BOOL_DEFAULTS = [EQUALS, NOT_EQUAL]
BOOL_DEFAULT_MOD = EQUALS

MODS = [
    EQUALS, NOT_EQUAL, GREATER_THAN, GREATER_THAN_EQUAL, LESS_THAN,
    LESS_THAN_EQUAL, IN, LIKE, STARTS_WITH, ENDS_WITH, ON, AFTER, BEFORE
]
